<?php

namespace App\controleur;
use App\config\Validation;
use App\gateway\Connection;
use App\gateway\ImageSaver;
use App\gateway\OffreGateway;
use App\modele\OffreModele;
use App\modele\ImageModele;
use App\modele\UtilisateurModele;

class UtilisateurControleur
{
    public function __construct()
    {
        global $twig;
        if (!isset($_REQUEST["action"])) {
           //$action = NULL;
            $action = "listerEvenement";
        } else {
            $action = Validation::nettoyerString($_REQUEST["action"]);
        }
        switch ($action) {
            case NULL:
            case "accueil":
                $this->accueil();
                break;
            case "connection":
                $this->connection();
                break;
            case "consulterOffres":
                $this->consulterOffres();
                break;
            case "consulterProfilLimite":
                $this->consulterProfilLimite();
                break;
            case "creerOffre":
                $this->creerOffre();
                break;
            case "testAction":
                $this->testAction();
                break;
            case "listerEvenement":
                $this->listerEvenement();
                break;
            case "creerEvenement":
                $this->creerEvenement();
                break;
            case "supprimerEvenement":
                $this->supprimerEvenement();
                break;
            case "avoirDetailEvenement":
                $this->avoirDetailEvenement();
                break;
            case "rechercherEvenement":
                $this->rechercherEvenement();
                break;
            default:
                $dVueErreur[] ="Action inconnue ou non autorisée";
                echo $twig->render("erreur.html",['dVueErreur' => $dVueErreur]);

        }
    }

    protected function connection()
    {
        global $twig;
        echo $twig->render('connexion.html', []);
    }

    protected function accueil()
    {
        global $twig;
        echo $twig->render('accueil.html', []);
    }

    protected function consulterProfilLimite()
    {
        //TODO
    }

    protected function consulterOffres()
    {
        global $twig;
        echo $twig->render('offres.html', []);
    }
    protected function creerOffre()
    {

        global $twig;
        echo $twig->render('CreerOffre.html', []);

       // echo '<img src="data:image/jpg;base64,' . base64_encode($imglist[0]->getBlob() ). '" height="100" width="100" alt="mon image" title="image"/>';*/

    }

    protected function publierOffre()
    {
        $imgMdl = new ImageModele;
        $offreMdl = new OffreModele();

        $img = $imgMdl->publierImage();
        $offreMdl->publierOffre($img);

        global $twig;
        echo $twig->render('Offres.html', [$offreMdl->obtenirOffres()]);
    }

    protected function testAction()
    {
        echo "test action ";
        $con = new Connection("mysql:host=localhost;dbname=dbAlica",'test','test');
        $offreGw = new OffreGateway($con);

        if($offreGw->getMaxid() == NULL)
            echo "max id == NULL";
        else echo "max id != NULL";
    }

    protected function listerEvenement()
    {
        $mdl = new UtilisateurModele();
        $evenements = $mdl->getEvenement();
        global $twig;

        echo $twig->render('evenement.html', ['evenements' => $evenements]);
    }

    protected function creerEvenement()
    {
        global $twig;

        if (isset($_FILES["image"])) {
            $img = ImageSaver::SaveImage('image');

            if (!Validation::validerEvenement($_POST["titre"], $_POST["description"], $_POST["date"], $_POST["nbPlaceMax"], $img[1])) {
                $mdl = new UtilisateurModele();
                $mdl->ajouterEvenement($_POST["titre"], $_POST["description"], $_POST["date"], $_POST["nbPlaceMax"], $img[1]);

                $this->listerEvenement();
            } else {
                $dVueErreur[] ="Erreur lors de la création de l'évènement";
                echo $twig->render("erreur.html",['dVueErreur' => $dVueErreur]);
            }
        } else {
            echo $twig->render('creerEvenement.html', []);
        }
    }


    protected function supprimerEvenement()
    {
        $mdl = new UtilisateurModele();
        $mdl->deleteEvenement($_GET["id"]);

        $this->listerEvenement();
    }

    protected function avoirDetailEvenement()
    {
        $mdl = new UtilisateurModele();
        $evenement = $mdl->getEvenementById($_GET["id"]);

        global $twig;
        echo $twig->render('detailEvenement.html', ['evenement' => $evenement]);
    }

    protected function rechercherEvenement()
    {
        $mdl = new UtilisateurModele();
        $evenements = $mdl->getEvenement();

        if(isset($_POST["recherche"]) AND !empty($_POST["recherche"]))
        {
            $recherche = Validation::nettoyerString($_POST["recherche"]);
            $evenements = $mdl->getEvenementByTitre($recherche);
        }

        global $twig;
        echo $twig->render('evenement.html', ['evenements' => $evenements]);
    }
}